from fovus.constants.cli_constants import (
    MAX_GPU,
    MAX_VCPU,
    MIN_GPU,
    MIN_GPU_MEM_GIB,
    MIN_VCPU,
    MIN_VCPU_MEM_GIB,
    PARALLELISM_OPTIMIZATION,
    SCALABLE_PARALLELISM,
)

BOUNDS = "bounds"
IS_INVALID_CORRECTABLE = "is_invalid_correctable"
CORRECTABLE_LIST_COMPREHENSION = "correctable_list_comprehension"
IS_INVALID_INCORRECTABLE = "is_invalid_incorrectable"
INCORRECTABLE_LIST_COMPREHENSION = "incorrectable_list_comprehension"
INCORRECTABLE_ERROR_MESSAGE_FROM_BOUNDS = "incorrectable_error_message_from_bounds"

BENCHMARK_NAME = "benchmarkName"
LIST_BENCHMARKING_FIELD_BY_CREATE_JOB_REQUEST_FIELD = {
    (MIN_VCPU, MAX_VCPU): "cpuRanges",
    (MIN_GPU, MAX_GPU): "gpuRange",
    (MIN_VCPU_MEM_GIB,): "cpuMemRanges",
    (MIN_GPU_MEM_GIB,): "gpuMemoryRange",
    (SCALABLE_PARALLELISM,): "scalableParallelism",
    (PARALLELISM_OPTIMIZATION,): "parallelismOptimization",
}

COMPARISONS = [IS_INVALID_INCORRECTABLE, IS_INVALID_CORRECTABLE]
COMPREHENSIONS = [INCORRECTABLE_LIST_COMPREHENSION, CORRECTABLE_LIST_COMPREHENSION]

CPU_RANGE_BOUNDS = ((MIN_VCPU, MAX_VCPU),)
CPU_MEM_RANGE_BOUNDS = ((MIN_VCPU_MEM_GIB,),)

DEFAULT_LOWER_BOUNDS_TO_VALIDATE = [(MIN_VCPU_MEM_GIB,)]
DEFAULT_UPPER_BOUNDS_TO_VALIDATE = []  # type: ignore
DEFAULT_BOOLEANS_TO_VALIDATE = [(SCALABLE_PARALLELISM,), (PARALLELISM_OPTIMIZATION,)]
DEFAULT_WITHIN_BOUNDS_TO_VALIDATE = [(MIN_VCPU, MAX_VCPU)]

GPU_LOWER_BOUNDS_TO_VALIDATE = [(MIN_GPU_MEM_GIB,)]
GPU_UPPER_BOUNDS_TO_VALIDATE = []  # type: ignore
GPU_WITHIN_BOUNDS_TO_VALIDATE = [(MIN_GPU, MAX_GPU)]

HYPERTHREADING_ENABLED = "hyperthreadingEnabled"
HYPERTHREADING_DISABLED = "hyperthreadingDisabled"
